﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Windows.Input;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Syncfusion.UI.Xaml.Diagram;
using Selector = Syncfusion.UI.Xaml.Diagram.Selector;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace F116314_SelectorCommandSupress
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();

            //Creating Custom SelectorViewmodel
            Diagram.SelectedItems = new SelectorVM();
            
            //To Suppress Selector Commands
            (Diagram.SelectedItems as ISelector).QuickCommands = Visibility.Collapsed;
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private void ButtonBase_OnClick(object sender, RoutedEventArgs e)
        {
            
        }
    }

    public class SelectorVM : SelectorViewModel
    {

       public SelectorVM()
        {
            ClickCommand = new Command(OnClick);
        }

        private ICommand _clickCommand;

        public ICommand ClickCommand
        {
            get
            {
                return _clickCommand;
            }
            set
            {
                if (_clickCommand != value)
                {
                    _clickCommand = value;
                    OnPropertyChanged("ClickCommand");
                }
            }
        }

        private void OnPropertyChanged(string p)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged.Invoke(this,new PropertyChangedEventArgs(p));
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;

        private void OnClick()
        {
            
        }
    }

    public class Command : ICommand
    {
        private Action _execute;

        public Command()
        {
            
        }

        public Command(Action action) : this()
        {
            _execute = action;
        }
        public bool CanExecute(object parameter)
        {
            return true;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
           _execute.Invoke();
        }
    }
}
